<!-- [QPRTemplateStart: actionhierarchytreeview.js] -->
  var _sSelectedObjectId;
  var _bSaveTreeState = true;
  var _sDefaultQueryFields = "hierarchy,creator,lastmodifieddate,category,attachments";
  var _sDefaultQueryFilters = "";
  var _sDefaultQuerySortBy = "-lastmodifieddate,header";
  var _sConfigurationFile = "actionhierarchyfields.ini";
  var _sHierarchy = "actions";
  var _iProductId = 4;

  function sGetViewSettingGroup()
  {
    return "actionhierarchy";
  }

  function bIsNativeView()
  {
    var oHeaderView = oGetHeaderView();
    return oHeaderView &&
           (oHeaderView.bIsCurrentView("actions", "discussion") ||
            oHeaderView.bIsCurrentView("processes", "PGPLUGIN_actions") ||
            oHeaderView.bIsCurrentView("scorecards", "SCPLUGIN_actions"));
  }

  function sGetViewName()
  {
    return sGetBookmarkDefaultName();
  }

  function sGetBookmarkDefaultName()
  {
    if (parent && bExists(parent.sGetBookmarkDefaultName))
      return parent.sGetBookmarkDefaultName()
    else
      return "";
  }
  
  function sGetRootName()
  {
    return _sRootObjectName;
  }

  function sGetCommonToolbarHTML()
  {
    try {
      return sGetBookmarkButton() +
             sGetAddToBasketButton() +
             sGetAttachActionButton();
    }
    catch (e) {
      return "";
    }
  }
  
  function sGetLocalToolbarHTML()
  {
    try {
      return sGetDesignerButtonHTML();
    }      
    catch (e) {
      return "";
    }
  }
  
  function getHelpContext() { return parent.getHelpContext(); }
  
  function sGetViewId()
  {
    var iBookmarkId = sGetParameter("BOOKMARK", sGetDocumentLocation());
    if (iBookmarkId)
      return iBookmarkId;
    return sGetCurrentRoots();
  }

  function OpenActionDetailsView(viId)
  {
    OpenDetailsForId(viId);
  }

  function bHighlightObjectById(vsId)
  {
    if (vsId.indexOf("_") == -1)
      vsId = sCreateExternalObjectId(PR_PORTAL, 0, vsId);

    if (vsId && (vsId != ""))
      return SetObjectSelectedStateByObjectIdValue(vsId);
    return false;
  }

  function OnLoadEx()
  {
    OnLoad();

    // Try to open action detais view
    var bDetailsOpened = false;
    var sAId = sGetParameter(ACT_PARAM_ASSOCIATION_ID, sGetDocumentLocation());
    // First try to open the action given in URL parameter
    if (sAId && bHighlightObjectById(sAId))
    {
      var oDetailsPane = oGetDetailsPane();
      if (!oDetailsPane || !oDetailsPane.sGetObjectId || (oDetailsPane.sGetObjectId() != sAId))
      {
        OpenActionDetailsView(sAId);
        bDetailsOpened = true;
      }
    }
    // Then try to open the last selected action
    if (!bDetailsOpened)
    {
      var oHeaderView = oGetHeaderView();
      if (oHeaderView && oHeaderView.sGetNamedVariableValue)
      {
        var sSelectedId = oHeaderView.sGetNamedVariableValue(sGetViewSettingGroup() + "_SelectedObject");
        if (sSelectedId && bHighlightObjectById(sSelectedId, true))
        {
          OpenActionDetailsView(sSelectedId);
          bDetailsOpened = true;
        }
      }
    }
    // Finally try to open the first available action
    if (!bDetailsOpened && (document.links.length > 0))
    {
      for (var i = 0; i < document.links.length; ++i)
      {
        var oLink = document.links[i];
        if (oLink.name == "tl")
        {
          eval(oLink.href);
          break;
        }
      }
    }

    if (parent && bExists(parent.OnTreeLoaded))
      parent.OnTreeLoaded();

    if (typeof(OnObjectQueryViewLoaded) != "undefined")
      OnObjectQueryViewLoaded();
  }

  function OnUnload()
  { 
    if (_bSaveTreeState) {
      var oHeaderView = oGetHeaderView();
      if (oHeaderView && oHeaderView.SetNamedVariableValue)
        oHeaderView.SetNamedVariableValue(sGetViewSettingGroup() + "_SelectedObject", _sSelectedObjectId ? _sSelectedObjectId : "", true);

      var oMain = oGetMainView();
      if (oMain && oMain.OnServerCookieViewUnloaded)
        oMain.OnServerCookieViewUnloaded(parent);
    }
  }
  
  function AddCookieState(voContainer)
  {
    var sCookie = _sRoot + "&" + (_sSelectedObjectId ? _sSelectedObjectId : "") + "&" + sGetExpandedNodes();
    voContainer.SetValue("ActionHierarchyView", sCookie);
  }

  function sAddDynamicState(vsURL)
  {
    if (_sSelectedObjectId)
      return sSetParameter(ACT_PARAM_ASSOCIATION_ID, _sSelectedObjectId, vsURL);
    return vsURL;
  }
  
  function sAddDynamicStateToBookmarkURL(vsURL)
  {
    if (_sSelectedObjectId) {
      var sURL = sDecodeURI(sGetParameter(ACT_PARAM_URL, vsURL));
      sURL = sAddDynamicState(sURL);
      return sSetParameter(ACT_PARAM_URL, sEncodeURI(sURL), vsURL);
    }
    return vsURL;
  }
  
  function OpenInformationView(vsURL, vsObjectId, vbDoNotRecurseIntoOpener)
  {
    _OpenInformationView(vsURL, vsObjectId, vbDoNotRecurseIntoOpener);
  }
  
  function PreventTreeStateSaving()
  {
    _bSaveTreeState = false;
    var oBody = document.getElementById("body");
    if (oBody)
      oBody.style.display = "none";
  }
  
<!-- [QPRTemplateEnd: actionhierarchytreeview.js] -->
